#!/bin/sh
#
# ACCESS CONFIGURATION - WEBADMIN SCRIPT
# Claudio Roberto Cussuol - claudio_cl@rictec.com.br
# Steve Eisner - seisner@comcast.net
# 2/12/2003
#

. /var/http/web-functions

SCRIPT="firewall.cgi"
FILE="/etc/coyote/firewall"
TMPFILE="/etc/coyote/acctemp"
RELOAD="/etc/rc.d/rc.firewall"
COLOR="#ECECEC"

#==================================
output_line() {
#==================================
  echo "<tr bgcolor=$COLOR>"
  [ "$DACTIVE" = "Yes" ] && echo "<td align=center><font color="#00AA00"><small>$DACTIVE</font></small></td>"
  [ "$DACTIVE" = "No" ] && echo "<td align=center><font color="#CC0000"><small>$DACTIVE</font></small></td>"
  echo "<td align=center><small>$DTYPE</small></td>"
  echo "<td align=center><small>$DRULE</small></td>"
  echo "<td align=center><small>$DPROTO</small></td>"
  echo "<td align=center><small>$DSRC</small></td>"
  echo "<td align=center><small>$DDEST</small></td>"
  echo "<td align=center><small>$DPORT</small></td>"
  echo "<td align=left nowrap><small>$DCOMMENT</small></td>"
  echo "<td align=center nowrap><small>"
  echo "<a href=$SCRIPT?ACTION=CALL_EDIT&LINE=$LINECOUNT>&nbsp;[Edit]&nbsp;</a>"
  echo "<a href=$SCRIPT?ACTION=DELETE&LINE=$LINECOUNT>&nbsp;[Delete]&nbsp;</a>"
  echo "</small></td>"
  echo "</tr>"
  if [ "$COLOR" = "#ECECEC" ] ; then COLOR="#DADADA"; else COLOR="#ECECEC"; fi
}

#==================================
set_address() {
##==================================
  PP="$1"
  NOT=`echo "$PP" | cut -c -3`
  if [ "$NOT" = "not" ] ; then
    PP=`echo "$PP" | cut -c 5-`
  else
    NOT=""
  fi
  TAG=`echo "$PP" | cut -c -3`
  if [ "$TAG" = mac ] ; then
    PP=`echo "$PP" | cut -c 5-`
    ADDRESS="$PP"
  else
    TAG="$PP"
    case $PP in
      lan|lan2|lan3|lan-if|lan-net|lan2-net|lan3-net) ADDRESS="";;
      int|int2|int3|int-if|int-net|int2-net|int3-net) ADDRESS="";;
      dmz|dmz2|dmz3|dmz-if|dmz-net|dmz2-net|dmz3-net) ADDRESS="";;
      any|all)  ADDRESS="";;
      *) ADDRESS="$PP"
         TAG="ip"
         return 0 ;;
    esac
  fi  
}

#==================================
desc_tag() {
#==================================
  case "$1" in
    any)      DTAG="Any" ;;
    ip)       DTAG="IP or Host Name" ;;  
    mac)      DTAG="MAC" ;; 
    lan-net)  DTAG="Local Network" ;;
    lan-if)   DTAG="Local Interface" ;;
    lan)      DTAG="Local IP Address" ;;
    lan2-net) DTAG="Local 2nd Network" ;;
    lan2)     DTAG="Local 2nd IP Address" ;;
    lan3-net) DTAG="Local 3rd Network" ;;
    lan3)     DTAG="Local 3rd IP Address" ;;
    int-net)  DTAG="Internet" ;;
    int-if)   DTAG="Internet Interface" ;;
    int)      DTAG="Internet IP Address" ;;
    int2-net) DTAG="Internet 2nd Network" ;;
    int2)     DTAG="Internet 2nd IP Address" ;;
    int3-net) DTAG="Internet 3rd Network" ;;
    int3)     DTAG="Internet 3rd IP Address" ;;
    dmz-net)  DTAG="DMZ Network" ;;
    dmz-if)   DTAG="DMZ Interface" ;;
    dmz)      DTAG="DMZ IP Address" ;;
    dmz2-net) DTAG="DMZ Second Network" ;;
    dmz2)     DTAG="DMZ Second IP Address" ;;
    dmz3-net) DTAG="DMZ Third Network" ;;
    dmz3)     DTAG="DMZ Third IP Address" ;;
  esac  
}

#==================================
treat_line() {
#==================================
  TYPE=$1
  if [ "$TYPE" = "admin" ] ; then METHOD="A"; else METHOD="F"; fi
  DTYPE=`echo $TYPE | tr [a] [A]`

  ACTIVE=$2
  if [ "$ACTIVE" = "y" ] ; then DACTIVE="Yes"; else DACTIVE="No"; fi

  RULE=$3
  [ "$RULE" != "permit" -a "$RULE" != "deny" ] && RULET="$RULE"
  DRULE=`echo $RULE | tr [p,d] [P,D]`

  PROTO=$4
  DPROTO=`echo $PROTO | tr [a-z] [A-Z]`
  if [ "$PROTO" != "tcp" -a "$PROTO" != "udp" -a "$PROTO" != "all" -a "$PROTO" != "icmp" ] ; then
     PROTON="$PROTO"
     PROTO=""
  fi  

  SRC_IP=$5
  set_address "$SRC_IP"
  SRC_NOT="$NOT"
  SRC_TAG="$TAG"
  SRC_IP="$ADDRESS"
  if [ -n "$NOT" ] ; then DNOT="Not " ; else DNOT=""; fi
  desc_tag "$TAG"
  if [ "$TAG" = "IP" ] ; then DTAG="" ; fi
  DSRC="$DNOT $DTAG $ADDRESS"

  DEST_IP=$6
  set_address "$DEST_IP"
  DEST_NOT="$NOT"
  DEST_TAG="$TAG"
  DEST_IP="$ADDRESS"
  if [ -n "$NOT" ] ; then DNOT="Not " ; else DNOT=""; fi
  desc_tag "$TAG"
  if [ "$TAG" = "IP" ] ; then DTAG="" ; fi
  DDEST="$DNOT $DTAG $ADDRESS"

  P7="$7"	
  PORT_NOT=`echo "$P7" | cut -c -3`
  if [ "$PORT_NOT" = "not" ] ; then
    P7=`echo "$P7" | cut -c 5-`
  else
    PORT_NOT=""
  fi
  if [ -n "$PORT_NOT" ] ; then DPORT_NOT="Not " ; else DPORT_NOT=""; fi
  DPORT=$DPORT_NOT`echo $P7 | tr [a-z] [A-Z]`
  START_PORT=`echo $P7 | cut -f 1 -d :`
  END_PORT=`echo $P7 | cut -f 2 -d :`
  [ "$START_PORT" = "$END_PORT" ] && END_PORT=""

  COMMENT=`echo $TMPLINE | sed s/.*#//`
  [ "$COMMENT" = "$TMPLINE" ] && COMMENT=""
  DCOMMENT=$COMMENT
}

#==================================
multi_line() {
#==================================
  while [ -n "$1" ] ; do
    if [ "$FIRST" != "S" ] ; then CONFIG_LINE=$CONFIG_LINE"\n" ; fi
    CONFIG_LINE=$CONFIG_LINE"access Y permit $2 $FORM_SRC_IP $FORM_DEST_IP $1 $FORM_COMMENT"
    FIRST="N"
    shift
    shift
  done
}

#==================================
mount_configuration() {
#==================================
  CONFIG_LINE=""
  if [ "$FORM_METHOD" = "A" -o "$FORM_METHOD" = "F" ]; then
    FORM_ACTIVE=`echo "$FORM_ACTIVE" | tr [y,n] [Y,N]`

    [ -z "$FORM_RULET" ] && [ -z "$FORM_RULE" ] && FORM_RULE="DROP"
    [ ! -z "$FORM_RULET" ] && FORM_RULE="$FORM_RULET"
    [ -z "$FORM_PROTOA" ] && [ -z "$FORM_PROTO" ] && FORM_PROTO="all"
    [ ! -z "$FORM_PROTOA" ] && FORM_PROTO="$FORM_PROTOA"
    [ "$FORM_PROTO" != "tcp" ] && [ "$FORM_PROTO" != "udp" ] && [ "$FORM_PROTO" != "icmp" ] && FORM_START_PORT="" && FORM_END_PORT="" && FORM_PORT_NOT=""

    if [ "$FORM_SRC" = "ip" -a "$FORM_SRC" = "mac" -a -z "$FORM_SRC_IP" ] ; then
      echo "<p><br><center><b>$Pda<pr></b></center><br></p>"
      return
    fi
    if [ "$FORM_SRC" != "ip" ] ; then
      if [ "$FORM_SRC" = "mac" ] ; then
        FORM_SRC_IP="mac:$FORM_SRC_IP"
      else
        FORM_SRC_IP="$FORM_SRC"
      fi  
    fi
    [ "$FORM_SRC_NOT" = "not" -a "$FORM_SRC_IP" != "any" ] && FORM_SRC_IP="not:$FORM_SRC_IP"

    if [ "$FORM_DEST" = "ip" -a "$FORM_DEST" = "mac" -a -z "$FORM_DEST_IP" ] ; then
      echo "<p><br><center><b>$Pdb<pr></b></center><br></p>"
      return
    fi
    if [ "$FORM_DEST" != "ip" ] ; then
      if [ "$FORM_DEST" = "mac" ] ; then
        FORM_DEST_IP="mac:$FORM_DEST_IP"
      else
        FORM_DEST_IP="$FORM_DEST"
      fi  
    fi
    [ "$FORM_DEST_NOT" = "not" -a "$FORM_DEST_IP" != "any" ] && FORM_DEST_IP="not:$FORM_DEST_IP"
  
    [ -z "$FORM_START_PORT" ] && FORM_START_PORT="all"
    if [ ! -z "$FORM_END_PORT" ] && [ "$FORM_START_PORT" -gt "$FORM_END_PORT" ]; then
      echo "<p><br><center><b>$Pdc<pr></b></center><br></p>"
      return
    fi
    [ ! -z "$FORM_END_PORT" ] && FORM_START_PORT="${FORM_START_PORT}:${FORM_END_PORT}"
    [ ! -z "$FORM_PORT_NOT" ] && FORM_START_PORT="not:$FORM_START_PORT"

    [ ! -z "$FORM_COMMENT" ] && FORM_COMMENT="#$FORM_COMMENT"
    [ "$FORM_METHOD" = "A" ] && CONFIG_LINE="admin $FORM_ACTIVE $FORM_RULE $FORM_PROTO $FORM_SRC_IP $FORM_DEST_IP $FORM_START_PORT $FORM_COMMENT"
    [ "$FORM_METHOD" = "F" ] && CONFIG_LINE="access $FORM_ACTIVE $FORM_RULE $FORM_PROTO $FORM_SRC_IP $FORM_DEST_IP $FORM_START_PORT $FORM_COMMENT"
  fi
}

#==================================
show_list() {
#==================================
#<td align="center" ><b>Line#</td>
cat << CLEOF
<table border="0" width="100%">
<tr><td width="100%" colspan=9 bgcolor="#000080">
<p align="center"><font color="#FFFFFF"><b>$Pdd</b></font>
</p></td></tr>
<tr bgcolor="#000080">
<td align="center" ><font color="#FFFFFF"><b>$Faj</b></font></td>
<td align="center" ><font color="#FFFFFF"><b>$Fak</b></font></td>
<td align="center" ><font color="#FFFFFF"><b>$Fal</b></font></td>
<td align="center" ><font color="#FFFFFF"><b>$Paj</b></font></td>
<td align="center" nowrap><b><font color="#FFFFFF">$Fam</b></font></td>
<td align="center" nowrap><b><font color="#FFFFFF">$Fan</b></font></td>
<td align="center" nowrap><font color="#FFFFFF"><b>$Fao</b></font></td>
<td align="center" ><font color="#FFFFFF"><b>$Fad</b></font></td>
<td align="center" ><font color="#FFFFFF"><b>$fac</b></font></td></tr>
CLEOF

LINECOUNT=0
cat $FILE | while read TMPLINE; do
  LINECOUNT=$(($LINECOUNT+1))
  TMPLINE2=`echo "$TMPLINE" | cut -f 1 -d \# | tr [A-Z] [a-z]`
  case "$TMPLINE2" in 
    \#*|"") 
      continue ;;
    admin*|access*) 
      treat_line $TMPLINE2
      output_line ;;
  esac
done
                                                                                                          
cat << CLEOF
</table><br>
<table><tr><td>
<b>$Pde</td><td></b> <a href=$SCRIPT?ACTION=CALL_ADD&METHOD=A>[ <u>$Pdf</u></a> &nbsp; | &nbsp;
<a href=$SCRIPT?ACTION=CALL_ADD&METHOD=F><u>$Pdg</u></a> ]<br></td></tr><tr><td>
<b>Control Actions:</td><td></b> <a href=$SCRIPT?ACTION=RELOAD>[ <u>$Pau</u></a> &nbsp; | &nbsp;
<a href="editconf.cgi?CONFFILE=/etc/coyote/firewall&DESCFILE=Firewall Configuration"><u>$Pav</u></a> &nbsp; | &nbsp;
<a href="editconf.cgi?CONFFILE=/etc/coyote/firewall.local&DESCFILE=Custom Firewall Rules"><u>$Pdh</u></a> ]
</td></tr></table>
<br>
CLEOF
}

#==================================
print_option () {
#==================================
  if [ -n "$2" ] ; then
    desc_tag "$1"	
    echo -n "<option value=$1"
    [ "$1" = "$SEL_TAG" ] && echo -n " selected" 
    echo ">$DTAG</option>"
  fi
}

#==================================
address_options () {
#==================================
echo "<select name="$1">"
  if [ "$1" = "SRC" ] ; then
    SEL_TAG="$SRC_TAG"
  else
    SEL_TAG="$DEST_TAG"
  fi  
  
  print_option any      "forced"
  print_option ip       "forced"
  print_option mac      "forced"

  print_option lan-net  "$LOCAL_IPADDR"
  print_option lan-if   "$LOCAL_IPADDR"
  print_option lan      "$LOCAL_IPADDR"
  print_option lan-net2 "$LOCAL_IPADDR2"
  print_option lan2     "$LOCAL_IPADDR2"
  print_option lan-net3 "$LOCAL_IPADDR3"
  print_option lan3     "$LOCAL_IPADDR3"

  print_option int-net  "forced"
  print_option int-if   "forced"
  print_option int      "forced"
  print_option int-net2 "$IPADDR2"
  print_option int2     "$IPADDR2"
  print_option int-net3 "$IPADDR3"
  print_option int3     "$IPADDR3"

  print_option dmz-net  "$DMZ_IPADDR"
  print_option dmz-if   "$DMZ_IPADDR"
  print_option dmz      "$DMZ_IPADDR"
  print_option dmz-net2 "$DMZ_IPADDR2"
  print_option dmz2     "$DMZ_IPADDR2"
  print_option dmz-net3 "$DMZ_IPADDR3"
  print_option dmz3     "$DMZ_IPADDR3"
 
  echo "</select>"
}

#==================================
show_form() {
#==================================
if [ "$METHOD" = "A" ] ; then
  FORMTITLE="$Pdi"
else  
  FORMTITLE="$Pdj"
fi

cat << CLEOF
<center>
<form method="POST" action="$SCRIPT">
  <input type=hidden value="$METHOD" name="METHOD">
  <input type=hidden value="$LINE"   name="LINE">
  <input type=hidden value="$ACTION" name="ACTION">
  <table border="0" width="100%">
    <tr>
      <td width="100%" colspan=2 bgcolor="#000080">
        <p align="center"><font color="#FFFFFF"><b>$FORMTITLE</b></font></p>
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Paz</b>
      <br>$Pba</td>
      <td bgcolor="#EDECEC">
        <input type="radio" value="n" name="ACTIVE" `[ "$ACTIVE" = "n" ] && echo checked`>$Fno &nbsp;
        <input type="radio" value="y" name="ACTIVE" `[ "$ACTIVE" != "n" ] && echo checked`>$Fye
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Fal</b>
      <br>$Pdk</td>
      <td bgcolor="#EDECEC">
        <input type="radio" name="RULE" value="permit" `[ "$RULE" = "permit" ] && echo checked`>$Fap
        <input type="radio" name="RULE" value="deny" `[ "$RULE" = "deny" ] && echo checked`>$Faq
        <br><input type="text" name="RULET" value="$RULET" size="17">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Paj</b>
      <br>$Pbn</td>
      <td bgcolor="#EDECEC">
        <select name="PROTOA">
	      <option value=""></option>
          <option value="all" `[ "$PROTO" = "all" ] && echo selected`>ALL</option>
          <option value="tcp" `[ "$PROTO" = "tcp" ] && echo selected`>TCP</option>
          <option value="udp" `[ "$PROTO" = "udp" ] && echo selected`>UDP</option>
          <option value="icmp" `[ "$PROTO" = "icmp" ] && echo selected`>ICMP</option>
        </select>
	    &nbsp; $Far &nbsp;
        <input type="text" name="PROTO" value="$PROTON" size="5">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Pdl</b>
      <br>$Pdm<br>$Pdn</td>
      <td bgcolor="#EDECEC">
        <input value="not" name="SRC_NOT" type="checkbox" `[ -n "$SRC_NOT" ] && echo " checked"`>Not</input></br>
        `address_options SRC`
        <br>
        <input type="text" name="SRC_IP" value="$SRC_IP" size="22">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Pdo</b>
      <br>$Pdp<br>$Pdq</td>
      <td bgcolor="#EDECEC">
        <input value="not" name="DEST_NOT" type="checkbox" `[ -n "$DEST_NOT" ] && echo " checked"`>Not</input></br>
        `address_options DEST`
        <br>
        <input type="text" name="DEST_IP" value="$DEST_IP" size="22">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Pbp</b>
        <br>$Pbr</td>
        <td bgcolor="#EDECEC">
        <input value="not" name="PORT_NOT" type="checkbox" `[ -n "$PORT_NOT" ] && echo " checked"`>Not</input></br>
        <input type="text" name="START_PORT" value="$START_PORT" size="22">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Pbr ($Fop)</b>
      <br>$Pbs</td>
      <td bgcolor="#EDECEC">
        <input type="text" name="END_PORT" value="$END_PORT" size="22">
      </td>
    </tr>
    <tr>
      <td align="right" bgcolor="#C0C0C0"><b>$Fad ($Fop)</b>
      <br>$Pbt
      <br>$Pbu ($Pbw "Web01 HTTP").</td>
      <td bgcolor="#EDECEC">
        <input type="text" name="COMMENT" value="$COMMENT" size="30">
      </td>
    </tr>
  </table>
  <p align="center"><input type="submit" value="$Fsb" name="OKBTN">
  &nbsp;&nbsp;<input type="reset"  value="$Fer"  name="B2"></p>
</form>
</center>
CLEOF
}

#==================================
# MAIN ROUTINE
#==================================

cl_header2 "$Pdd - Coyote Linux"

if [ "$FORM_OKBTN" = "$Fsb" ]; then
   mount_configuration
   if [ -n "$CONFIG_LINE" ] ; then
     if [ "$FORM_ACTION" = "ADD" ]; then
        echo -e $CONFIG_LINE >> $FILE
     else
       LINECOUNT=0  
       echo -n > $TMPFILE 
       cat $FILE | while read TMPLINE; do
         LINECOUNT=$(($LINECOUNT+1))
         if [ "$LINECOUNT" -ne "$FORM_LINE" ] ; then
           echo "$TMPLINE" >> $TMPFILE
         else
           echo $CONFIG_LINE >> $TMPFILE
         fi  
       done 
       rm -f $FILE
       mv $TMPFILE $FILE
       touch /tmp/need.save
     fi
     echo "<p><center><b><br>$Pcn<br>"
     echo "<a href=$SCRIPT?ACTION=RELOAD><u>$Pco</u></a><br>"
     echo "<a href=backup.cgi><u>$Wtl</u></a><br></b></center></p>"
   fi
fi

case "$FORM_ACTION" in
  "DELETE")
     LINECOUNT=0  
     echo -n > $TMPFILE 
     cat $FILE | while read TMPLINE; do
       LINECOUNT=$(($LINECOUNT+1))
       if [ "$LINECOUNT" -ne "$FORM_LINE" ] ; then
         echo "$TMPLINE" >> $TMPFILE
       fi  
     done 
     rm -f $FILE
     mv $TMPFILE $FILE
     touch /tmp/need.save
     echo "<p><center><b><br>$Pcp<br>"
     echo "<a href=$SCRIPT?ACTION=RELOAD><u>$Pco</u></a><br>"
     echo "<a href=backup.cgi><u>$Wtl</u></a><br></b></center></p>"
     show_list
     ;;
   "CALL_EDIT")
     TMPLINE=`head -n $FORM_LINE $FILE | tail -n 1`
     TMPLINE2=`echo "$TMPLINE" | cut -f 1 -d \# | tr [A-Z] [a-z]`
     treat_line $TMPLINE2
     ACTION="EDIT"
     LINE=$FORM_LINE
     show_form
     ;;
   "CALL_ADD")
     METHOD=$FORM_METHOD 
     ACTION="ADD"
     LINE=0
     ACTIVE="Y"
     RULE="permit"
     PROTO=""
     SRC_IP=""
     DEST_IP=""
     START_PORT=""
     END_PORT=""
     show_form
     ;;
   "RELOAD")
     echo "<br>"
     cr2br $RELOAD
     echo "<center><br><font size=4><a href=$SCRIPT>[ <u>$Fbk</u> ]</a><br></font></center>"
     ;;
   *)
     show_list
     ;;
esac

cl_footer2
