#!/bin/sh
#
# SIMPLIFIED FIREWALL CONFIGURATION
# Claudio Roberto Cussuol - claudio_cl@rictec.com.br
# 11/09/2004
#

. /var/http/web-functions
. /etc/coyote/coyote.conf

SCRIPT="sfirewall.cgi"
FILE="/etc/coyote/firewall"
TMPFILE="/etc/coyote/acctemp"
RELOAD="/etc/rc.d/rc.firewall"
COLOR="#ECECEC"

IP_BLACK_LIST=/tmp/sfw_ip_black_list
IP_WHITE_LIST=/tmp/sfw_ip_white_list
PORT_BLACK_LIST=/tmp/sfw_port_black_list
PORT_WHITE_LIST=/tmp/sfw_port_white_list
MAC_BLACK_LIST=/tmp/sfw_mac_black_list
MAC_WHITE_LIST=/tmp/sfw_mac_white_list
echo -n > $IP_BLACK_LIST
echo -n > $IP_WHITE_LIST
echo -n > $PORT_BLACK_LIST
echo -n > $PORT_WHITE_LIST
echo -n > $MAC_BLACK_LIST
echo -n > $MAC_WHITE_LIST

cl_header2 "$Msf - Coyote Linux"

if [ "$FORM_ACTION" = "RELOAD" ]; then
   echo "<br>"
   cr2br $RELOAD
   echo "<center><br><font size=4><a href=$SCRIPT>[ <u>$Fbk</u> ]</a><br></font></center>"
   cl_footer2
   exit 0
fi

if [ "$FORM_OKBTN" = "$Fsb" ]; then
  echo -n > $TMPFILE 
  cat $FILE | while read TMPLINE; do
    case "$TMPLINE" in 
      block_ip*|allow_ip*|block_mac*|allow_mac*|block_port*|allow_port*)
        continue ;;
      *)
        echo $TMPLINE >> $TMPFILE
    esac
  done 

  echo "$FORM_IP_BLACK_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo block_ip $TMPLINE >> $TMPFILE
  done 
  echo "$FORM_IP_WHITE_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo allow_ip $TMPLINE >> $TMPFILE
  done 
  echo "$FORM_PORT_BLACK_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo block_port $TMPLINE >> $TMPFILE
  done 
  echo "$FORM_PORT_WHITE_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo allow_port $TMPLINE >> $TMPFILE
  done 
  echo "$FORM_MAC_BLACK_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo block_mac $TMPLINE >> $TMPFILE
  done 
  echo "$FORM_MAC_WHITE_LIST" | while read TMPLINE; do
    [ -n "$TMPLINE" ] && echo allow_mac $TMPLINE >> $TMPFILE
  done 

  rm -f $FILE
  mv $TMPFILE $FILE

  DEFAULT_USERS_FILTER=$FORM_DEFAULT_USERS_FILTER
  DEFAULT_SERVICES_FILTER=$FORM_DEFAULT_SERVICES_FILTER
  cl_rebuildconf
  
  echo "<p><center><b><br>$Pcn<br>"
  echo "<a href=$SCRIPT?ACTION=RELOAD><u>$Pco</u></a><br>"
  echo "<a href=backup.cgi><u>$Wtl</u></a><br></b></center></p>"
fi

treat_line() 
{
  case $1 in 
    block_ip)   echo $2 >> $IP_BLACK_LIST ;;
    allow_ip)   echo $2 >> $IP_WHITE_LIST ;;
    block_mac)  echo $2 >> $MAC_BLACK_LIST ;;
    allow_mac)  echo $2 >> $MAC_WHITE_LIST ;;
    block_port) echo $2 $3 >> $PORT_BLACK_LIST ;;
    allow_port) echo $2 $3 >> $PORT_WHITE_LIST ;;
  esac
}

cat $FILE | while read TMPLINE; do
  LINECOUNT=$(($LINECOUNT+1))
  TMPLINE2=`echo "$TMPLINE" | cut -f 1 -d \# | tr [A-Z] [a-z]`
  case "$TMPLINE2" in 
    block_ip*|allow_ip*|block_mac*|allow_mac*|block_port*|allow_port*)
      treat_line $TMPLINE2 ;;
  esac
done

cat << CLEOF
<form method="POST" action="$SCRIPT">
<table border="0" width="100%">

  <tr>
    <td width="100%" colspan=4 bgcolor="#000080">
      <p align="center"><font color="#FFFFFF"><b>$Pna</b></font></p>
    </td>
  </tr>
  <tr>
    <td width="50%" colspan=2 bgcolor="#C0C0C0"><input type="radio"
      value="ALLOW_ALL" name="DEFAULT_USERS_FILTER"
      `[ "$DEFAULT_USERS_FILTER" != "BLOCK_ALL" ] && echo -n checked` >
      <b>$Pnd</b></td>
    <td width="50%" colspan=2 bgcolor="#C0C0C0"><input type="radio" 
      value="BLOCK_ALL" name="DEFAULT_USERS_FILTER"
      `[ "$DEFAULT_USERS_FILTER"  = "BLOCK_ALL" ] && echo -n checked` >
      <b>$Pne</b></td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    <b>$Pnj</b><br>$Pnm
    $Pnl<br>192.168.0.2<br>10.0.0.2</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="IP_BLACK_LIST" wrap=off>`cat $IP_BLACK_LIST`</textarea>
    </td>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    <b>$Pnk</b><br>$Pnn
    $Pnl<br>192.168.0.2<br>10.0.0.2</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="IP_WHITE_LIST" wrap=off>`cat $IP_WHITE_LIST`</textarea>
    </td>
  </tr>

  <tr>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    $Pno $Pnl<br>00:0a:02:0b:03:0c<br>01:0d:03:0e:00:0f</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="MAC_BLACK_LIST" wrap=off>`cat $MAC_BLACK_LIST`</textarea>
    </td>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    $Pnp $Pnl<br>00:0a:02:0b:03:0c<br>01:0d:03:0d:00:0f</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="MAC_WHITE_LIST" wrap=off>`cat $MAC_WHITE_LIST`</textarea>
    </td>
  </tr>

  <tr>
    <td width="100%" colspan=4 bgcolor="#000080">
      <p align="center"><font color="#FFFFFF"><b>$Pnb</b></font></p>
    </td>
  </tr>
  <tr>
    <td width="50%" colspan=2 bgcolor="#C0C0C0"><input type="radio"
      value="ALLOW_ALL" name="DEFAULT_SERVICES_FILTER"
      `[ "$DEFAULT_SERVICES_FILTER" != "BLOCK_ALL" ] && echo -n checked` >
      <b>$Pnh</b></td>
    <td width="50%" colspan=2 bgcolor="#C0C0C0"><input type="radio" 
      value="BLOCK_ALL" name="DEFAULT_SERVICES_FILTER"
      `[ "$DEFAULT_SERVICES_FILTER"  = "BLOCK_ALL" ] && echo -n checked` >
      <b>$Pni</b></td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    <b>$Pnj</b><br>$Pnq
    $Pnl<br>80 tcp<br>53 udp<br>20:21 tcp</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="PORT_BLACK_LIST" wrap=off>`cat $PORT_BLACK_LIST`</textarea>
    </td>
    <td width="25%" bgcolor="#EDECEC" align=left valign=top>
    <b>$Pnk</b><br>$Pnr
    $Pnl<br>80 tcp<br>53 udp<br>20:21 tcp</td>
    <td width="25%" bgcolor="#EDECEC">
    <textarea rows=7 cols=20 name="PORT_WHITE_LIST" wrap=off>`cat $PORT_WHITE_LIST`</textarea>
    </td>
  </tr>

</table>
<p align="center"><input type="submit" value="$Fsb" name="OKBTN"><input type="reset" value="$Fer" name="B2"></p>
</form>

<table><tr><td>
<b>Control Actions:</td><td></b> <a href=$SCRIPT?ACTION=RELOAD>[ <u>$Pau</u></a> &nbsp; | &nbsp;
<a href="editconf.cgi?CONFFILE=/etc/coyote/firewall&DESCFILE=Firewall Configuration"><u>$Pav</u></a> &nbsp; | &nbsp;
<a href="editconf.cgi?CONFFILE=/etc/coyote/firewall.local&DESCFILE=Custom Firewall Rules"><u>$Pdh</u></a> ]
</td></tr></table><br>
CLEOF
rm -f /tmp/sfw_* 1> /dev/null 2> /dev/null

cl_footer2
